Subject: Re: a F-RTO question

From: Li Yu <[email-masked]>
Date: Wed, 28 Mar 2012 12:08:41 +0800

于 2012年03月28日 11:49, Chao Pei 写道:
>> Hi,
>>
>>         I have a question about tcp_process_frto(), the below source
>> code :
>>
>> static int tcp_process_frto(struct sock *sk, int flag)
>> {
>>         .....
>>
>>         if (!before(tp->snd_una, tp->frto_highmark)) {
>>                 tcp_enter_frto_loss(sk, ...);
>>                 return 1;
>>         }
>>
>>         .....
>>
>> }
>>
>>         As my understanding, the tp->frto_highmark likes tp->high_seq,
>> it saves the seqno SND_NXT when a TCP connection enters F-RTO phase,
>> is it the variable "recovery" in NewReno? So I think that if snd_una is
>> equal with or after frto_highmark, which means peer ack new data, so
>> why we enter Loss state here?
>>
>>         Thanks!
>>
>> Yu
>>
>>
>
> If snd_una advances to frto_highmark, it is likely that the hole was
> filled by the retransimitted packet, which means the original packet
> was likely to have been lost.
> So, we should enter loss state.
>

I do not agree with it, if snd_una advanced to frto_highmark, which 
means peer acks whole window of data instead of just one segment, and
we can not make sure that reason of peer sends ack is whether it 
received original segment or retransmitted segment.

Even, the reason is latter, it also means the netowrk already is
recovered from temporarily congestion or disordered state, so we also 
should not enter loss state.

Thanks

Yu